﻿using System;
using System.Linq;
using System.Threading.Tasks;
using DeukBot4.Utilities;
using Discord.WebSocket;

namespace DeukBot4.MessageHandlers
{
    public static class MainHandler
    {
        public static async Task HandleMessage(SocketMessage message)
        {
            if (message.Author.Id == Program.Client.CurrentUser.Id)
            {
                return;
            }
            try
            {
#pragma warning disable 4014
                CommandHandler.CommandHandler.HandleMessage(message);
                HandlePrivateMessage(message);
                ImageBackupHandler.Backup(message);
                DeltaHandler(message);
#pragma warning restore 4014
            }
            catch (Exception e)
            {
                await Logger.LogError(e.ToString());
            }
        }

        private static async Task HandlePrivateMessage(SocketMessage message)
        {
            if (message.Channel is ISocketPrivateChannel)
            {
                await Logger.Log(($"Private Message: {message.Author.Username}- {message.Content}"));
            }
        }

        private static async Task DeltaHandler(SocketMessage message)
        {
            var lowerCasedContent = message.Content.RemoveSpecialCharacters();
            if (lowerCasedContent.Contains("origin"))
                return;

            var lowerSplit = lowerCasedContent.Split(' ');
            if (lowerSplit.Select(s => Lehvenstein.LevenshteinDistance(s, "delta")).Any(diff => diff <= 1))
            {
                await message.Channel.SendMessageAsync("uhh excuse me it's called Origin and it's an art");
            }

        }
    }
}